# yamllint disable
# License: Commons Clause License Condition v1.0[LGPL-2.1-only]
# yamllint enable
---
rules:
- id: "ruby_xss_rule-ManualTemplateCreation"
  pattern: ERB.new(...)
  message: |
    The application was identified manually creating ERB templates. Manual creation of templates
    may expose your application to server-side template injection (SSTI) or
    cross-site scripting (XSS) attacks if user input is used to create the
    template. Instead, create a '.erb' template file and use 'render'.

    Secure Code Example:
    ```
    # Controller: messages_controller.rb
    class MessagesController < ApplicationController
      def show
        # Safely assign user input to an instance variable
        @message_content = sanitize(params[:user_content])
        
        # Render the static .erb template
        render 'messages/show'
      end
    end
    
    <!-- Static ERB Template Example - app/views/messages/show.html.erb -->
    <div>
      Message: <%= @message_content %>
    </div>
    ```
  languages: 
  - "ruby"
  severity: "WARNING"
  metadata:
    shortDescription: "Improper neutralization of input during web page generation
      ('Cross-site Scripting')"
    category: "security"
    cwe: "CWE-79"
    owasp:
    - "A7:2017-Cross-Site Scripting (XSS)"
    - "A03:2021-Injection"
    security-severity: "MEDIUM"
    technology:
    - "rails"
    references:
    - "https://github.com/semgrep/semgrep-rules/blob/develop/ruby/rails/security/audit/xss/manual-template-creation.yaml"

  
  